'''
Created on 26/04/2015

@author: david
'''
import time
from pyCSE import pyCSE
from pyCSE import scanSE
from threading import Thread

'''
Opcio de implementar la lectura de dades, com a una tasca paralela.
Finalment s'opta per una solució mes senzilla (recompilar dades
al final del process), i aquesta es desactiva.
''' 
'''
def readerLoop(tramaID, mstime):
    while True:
        print ('reader loop')
        paquet = CSE.getResposta(tramaID)
        if paquet == None:
            print ('sense dades')
        else:
            myScaner = scanSE.Scaner(paquet)
            dades = myScaner.getDades()
            linea = 'valors '
            for element in dades:         
                calc= float(element) / 1000
                linea += str(calc) + ' '
            print (linea)
        time.sleep(mstime/1000)
'''                    

def controlar_led():
    valor = 0;    
    while (valor != 9):        
        print(" ")
        print("Accions sobre el Led de la placa")
        print("--------------------------------")           
        print( "[1] Encendre Led - ledOn( )" )
        print( "[2] Apagar Led - ledOff( )" )
        print( "[3] Inverteix estat - ledBlink(0)" )
        print( "[4] Canvi periodic - ledBlink(t)" )       
        print( "[9] Tornar")
        valor = int(input())
        if valor == 1:
            CSE.ledOn()             
        elif valor == 2:
            CSE.ledOff()                        
        elif valor == 3:
            CSE.ledBlink(0)            
        elif valor == 4:
            print( "Informa els milisegons:")
            mstime = int(input())
            CSE.ledBlink(mstime)        
    return

def controlar_ADC():
    valor = 0    
    while (valor != 9):   
        print(" ")
        print("Entrada dades ADC")
        print("--------------------------------")
        print( "[1] Lectura ADC - getADC(0, Port)" )
        print( "[2] Lectura sensor 3 eixos - getADC(0, Ports[0,1,2])" )
        print( "[3] Lectura periodica ADC - getADC(t, Ports[0,1,2])" )        
        print( "[9] Tornar")
        caracter = input()
        if caracter.isnumeric():
            valor = int(caracter)
            if valor == 1:
                print ("selecciona port [0 a 5]")                
                port = int(input())
                listPorts = []            
                listPorts.append(port)
                dades = CSE.getADC(0, listPorts)
                linea = 'valors '
                for element in dades:         
                    calc= float(element) / 1000
                    linea += str(calc) + ' '                
                print (linea)
            elif valor ==2:
                listPorts = [0,1,2]                                        
                dades = CSE.getADC(0, listPorts)
                linea = 'valors '
                for element in dades:         
                    calc= float(element) / 1000
                    linea += str(calc) + ' '                
                print (linea)
            elif valor ==3:
                print( "Informa els milisegons:")
                mstime = int(input())
                listPorts = [0,1,2] 
                tramaId = CSE.getADC(mstime,listPorts)
                print( "Pulsa enter per veure els resultats")
                input()
                '''
                opció de lectura paralela desactivada. Es recompilen dades al final.
                #reader = Thread(target=readerLoop, args=(tramaId,mstime,) )
                #reader.start()
                '''
                paquet = CSE.getResposta(tramaId)
                for element in paquet:                    
                    myScaner = scanSE.Scaner(element)
                    dades = myScaner.getDades()
                    linea = 'valors '
                    for element in dades:         
                        calc= float(element) / 1000
                        linea += str(calc) + ' '
                    print (linea)        
                CSE.getADC(0,[])                
    return

def controlar_UART():
    valor = 0
    numUART = 0;
    speedUART = 9600;
    while (valor != 9):   
        print(" ")
        print("Accions sobre la UART")
        print("--------------------------------")
        print("Port " + str(numUART) + " Velocitat " + str(speedUART)  ) 
        print( "[1] Modifica Canal") 
        print( "[2] Modifica velocitat") 
        print( "[3] Lectura UART - getUART( port, speed ) " )
        print( "[4] Escritura UART - sendUART( port, speed, text )" )        
        print( "[9] Tornar")
        caracter = input()
        if caracter.isnumeric():
            valor = int(caracter)
            if valor == 1:            
                print ("selecciona port [0,1 o 3]")                
                numUART = int(input())             
            elif valor == 2:
                print ("selecciona velocitat")                
                speedUART = int(input())   
            elif valor == 3:
                dades = CSE.getUART(numUART,speedUART);
                print( str(dades))
            elif valor == 4:      
                print ("Informa el text a enviar:")
                text = input()
                dades = CSE.sendUART(numUART, speedUART, text);
                print( str(dades))          
    return

def controlar_GPIO(): 
    valor = 0   
    numPin = 0;    
    while (valor != 9):   
        print(" ")
        print("Control de pins (GPIO)")
        print("--------------------------------")        
        print( "[1] Consulta estat - pinGet(p)")
        print( "[2] Activa pin - pinSet( p, H)")
        print( "[3] Desactiva pin - pinSet( p, L )" )                
        print( "[9] Tornar")
        caracter = input()
        if caracter.isnumeric():
            valor = int(caracter)
            if valor == 1:            
                print ("selecciona pin:")                
                numPin = int(input())
                estatList = CSE.pinGet(numPin)
                for estat in estatList:
                    if estat == 1:                
                        print ("Estat=High")
                    elif estat == 0:
                        print ("Estat=Low")
                    else:
                        print ("Estat=" + str(estat))  
            elif valor == 2:
                print ("selecciona pin:")                
                numPin = int(input())                
                CSE.pinSet( numPin, 'H')   
            elif valor == 3:
                print ("selecciona pin:")                
                numPin = int(input())                
                CSE.pinSet( numPin, 'L')                    
    return

def controlar_SPI():
    valor = 0
    while (valor != 9):   
        print( "[1] getSPI" )
        print( "[2] sendSPI" )        
        print( "[9] Tornar")
        caracter = input()
        if caracter.isnumeric():
            valor = int(caracter)
            if valor == 1:            
                dades = CSE.getSPI(0)
                linea = 'valors '
                for element in dades:
                    linea += str(element)
                print (linea)
            elif valor == 2:      
                print ("Informa el text a enviar:")
                text = input()
                dades = CSE.sendSPI(0, text);
                print( str(dades))                             
    return
    
def controlar_I2C():
    valor = 0
    while (valor != 9):   
        print( "[1] getI2C" )
        print( "[2] sendI2C" )        
        print( "[9] Tornar")
        caracter = input()
        if caracter.isnumeric():
            valor = int(caracter)
            if valor == 1:            
                dades = CSE.getI2C()
                linea = 'valors '
                for element in dades:
                    linea += str(element)
                print (linea)            
    return
    
if __name__ == '__main__':
    valor = 0
    CSE = pyCSE.PyCSE()
    if (CSE.serialConnection() == 1 ):
        while valor != 9:
            print('-----------------------------------------')
            print(' aplicació sobre API pyCSE (protocol CSE)')
            print('-----------------------------------------')
            print("[1] Control de Led")
            print("[2] control ADC")
            print("[3] control UART")
            print("[4] GPIO control de pins")
            print("[5] Control SPI")
            # print("[6] Control I2C")
            # print("[7] Log view")                    
            print("[9] Sortir")
            caracter = input()
            if caracter.isnumeric:
                valor = int(caracter)
                if (valor == 1):
                    controlar_led()                
                elif (valor == 2):
                    controlar_ADC() 
                elif (valor == 3 ):
                    controlar_UART()                    
                elif (valor == 4 ):
                    controlar_GPIO()
                elif (valor == 5 ):
                    controlar_SPI()
                elif (valor == 6):
                    controlar_I2C()
                elif (valor == 7):
                    CSE.showLog()
            pass
    else:
        print("not open connection ")
    pass


    