/*
 * pinControl.h
 *
 *  Created on: 8/6/2015
 *      Author: david
 */

#ifndef INC_PINCONTROL_H_
#define INC_PINCONTROL_H_

/* Informa els parametres del control de pins
 * @precondition 	Parametres correctes, en ordre correcte
 *					1er el port de la placa
 *					2on el numero de Bit
 * @param ptParm	aPuntador al valor del paràmetre
 * @param size		Mida en bytes del paràmetre
 *
 * @return void
 */
void PinControl_set(unsigned int * ptParm, unsigned char size);

/* Realitza la operació solicitada sobre el pin ( ON/OFF/GetState)
 * @precondition 	S'han fet les crides previes a PinControlSet
 * @param action	Acció a realitzar ( ON/OFF/GetState)
 * @return void
 */
void PinControl_run(unsigned short int action);

#endif /* INC_PINCONTROL_H_ */
