/*
 * uartControl.c
 *
 *  Created on: 31/5/2015
 *      Author: david
 */


#include "type.h"
#include "uart.h"
#include "PrintF.h"
#include "ProtocolSE.h"

int uart_countParm = 0;
int uart_port = 0;
int uart_speed = DEFAULT_SPEED;
char uart_text[255];
unsigned char uart_textSize = 0;

void uartControl_set(unsigned int * ptParm, unsigned char size){
	uart_countParm++;
	if (uart_countParm == 1) {
		uart_port = *ptParm;
	}
	else if (uart_countParm == 2) {
		uart_speed = *ptParm;
	}
	else if (uart_countParm == 3) {
		strcpy( uart_text, (char * ) ptParm);
		uart_textSize = size;
	}
}

void uartControl(unsigned short int action){
	unsigned short int disp = ID_UART;
	unsigned char mida = 0;
	uint32_t Data = 0;
	PrintF_start( uart_port, uart_speed);
	if ( action == ID_GET ) {
		mida = PrintF_scan(uart_port, uart_text, 1);
		generate_Stream( disp, Data, mida);
	}
	if ( action == ID_SET ) {
		PrintF_stream(uart_port, uart_text, uart_textSize );
	}
	else PrintF_print (3, "error action" );
	uart_countParm = 0;
}

