#ifndef LIBUOC_INC_LOG_H
#define LIBUOC_INC_LOG_H_



/* Configuració del Log
 * @precondition 	Cap*
 * @param portNum	Port de la UART ( 0, 1 o 3 )
 * @param baudrate	Velocitat de transmissió en baudis
 *
 * @return void
 */
void Log_start(uint32_t portNum, uint32_t baudrate);

/* Envia dades al Log (amb sortida al port serie)
 * @precondition 	Haver fet un Log_start() previament
 *
 * @param format	Mateix format que el printf(). Multivariable.
 *
 * @return void
 */
void Log_log(const char * format, ... );

#endif /* LIBUOC_INC_PRINTF_H */
