/*
 * Log.c
 *	Modulo con funciones para generar un Log de salida, por el puerto serie.
 *  Created on: 28/3/2015
 *      Author: david
 */
#include "stdio.h"
#include "stdarg.h"
#include "string.h"
#include "LPC17xx.h"
#include "type.h"
#include "uart.h"
#include "PrintF.h"


uint32_t portLog;
uint32_t velocitatLog;


void Log_start(uint32_t portNum, uint32_t baudrate){
	portLog = portNum;
	velocitatLog = baudrate;
	//PrintF_start( portNum, baudrate);
}

void Log_log(const char * format, ... ){
	va_list lv; 		// Llista de paràmetres
	char log[255];
	char * logformat = log;
	char * ptrText;
	va_start( lv, format);
	sprintf( log, "fwLog: " );
	ptrText = &log[strlen(log)];
	vsnprintf( ptrText, 200, format,  lv );
	logformat = strcat(logformat, "\r\n");
	va_end( lv );
	PrintF_print( portLog, logformat );
}

