'''
Created on 30/05/2015

@author: david
'''
from pyCSE import defSE
import struct

#class const:
#    COMMAND_SIZE = 5
    
class Dada(object):
    mida = 0
    tipus = 0
    def __init__(self, tipus, valor): 
        self.tipus = tipus
        self.valor = valor
    
    def getTipus(self):
        return self.tipus
    
    def getValue(self):
        return self.valor
        
class Body(object):
    '''
    classdocs
    '''
    comp  = '00'
    ins   = '00'
    parms = 0       
    size  = defSE.val.COMMAND_SIZE
    llistaDades = []

    def __init__(self):         
        self.llistaDades.clear()
        self.parms = 0        
        pass     
    
    def setComponent(self, component):        
        self.comp = component 
        
    def setAction(self, action):        
        self.ins = action
    
    def addByte(self, num):
        newDada = Dada('B', num)
        self.llistaDades.append(newDada)
        self.parms +=1 
        self.size += 2
    
    def addNum(self,num):  
        newDada = Dada('I', num)
        self.llistaDades.append(newDada)
        self.parms += 1
        self.size += 5
    
    def addText(self, text):
        newDada = Dada('T', text)
        self.llistaDades.append(newDada)
        self.parms += 1
        self.size += len(text) + 1
                        
    def getBytes(self):
        s = struct.Struct('5B')        
        stream = s.pack( self.comp[0], self.comp[1],  
                         self.ins[0],  self.ins[1],
                         self.parms)
        for elemento in self.llistaDades:
            tipus = elemento.getTipus()            
            if tipus == 'B':
                valor = elemento.getValue()
                streamByte = struct.pack('<2B', 1, valor )
                stream += streamByte
                # print(str(streamByte))
            elif tipus == 'I':
                valor = elemento.getValue()                
                streamNum = struct.pack('<BI', 4, valor )
                stream += streamNum
                # print(str(streamNum))
            elif tipus == 'T':
                valor = elemento.getValue()
                mida = len(valor)
                stream += struct.pack('B', mida)
                stream += bytes(valor,'us-ascii')
        s = struct.Struct( str(self.size) + 'B')        
        #print ('[body]stream=' + str(s.unpack(stream)) + 'size=' + str(self.size) )
        return stream
    
    def getSize(self):
        return self.size
    
    def getDades(self):        
        newList = []
        for element in self.llistaDades:
            # print('element Llista = ' + str(element))
            newList.append(element)
        return newList            
        
    
    def loadBytes(self, byteStream):            
        # print ('trama stream=' + str(s.unpack(byteStream)) )
        self.comp  = byteStream[0:2]
        self.ins   = byteStream[2:2]
        self.parms = byteStream[4]
        i = 1
        count = defSE.val.COMMAND_SIZE        
        # print("body load parms=" + str(self.parms))
        while i <= self.parms: 
            mida = byteStream[count]
            count+=1
            # print("count=" + str(count) + " mida=" + str(mida))
            if mida == 4:            
                si = struct.Struct( '<I' )
                valor = si.unpack_from(byteStream, count)
                # print("valor[i]=" + str(valor))
                self.llistaDades.append(valor[0])  
            else:                
                si = struct.Struct( mida + 'B' )
                valor = si.unpack_from(byteStream, count)
                self.llistaDades.append(valor)  
            count+=mida
            i+=1
            
    