'''
Created on 07/06/2015

@author: david
'''

from pyCSE import componentSE
from pyCSE import defSE

class Pin(componentSE.ComponentSE):
    '''
    classdocs
    Control per consultar i modificar el estat dels pins
    '''    
    ''' Dicionari Pins = [port , bit] '''
    dicPins = { 5:[0,9], 6:[0,8], 7:[0,7], 8:[0,6], 9:[0,0], 10:[0,1], 
                11:[0,18], 12:[0,17], 13:[0,15], 14:[0,16], 15:[0,23],
                16:[0,24], 17:[0,25], 18:[0,26], 19:[1,30], 20:[1,31], 21:[0,2],
                22:[0,3], 23:[0,21], 24:[0,22], 25:[0,27], 26:[0,28], 27:[2,13],
                38:[0,4], 39:[0,5], 40:[0,10], 41:[0,11], 42:[2,0], 43:[2,1], 
                44:[2,2], 45:[2,3], 46:[2,4], 47:[2,5], 48:[2,6], 49:[2,7],
                50:[2,8], 51:[2,10], 52:[2,11], 53:[2,12] }

    numPin = 0    
            
    def __init__(self):
        '''
        Constructor
        '''
        super(Pin, self).setType(defSE.val.PIN_CODE)
        super(Pin, self).setAction(defSE.val.GET_ACTION_CODE)
        
    def pinGet(self, numPin):        
        super(Pin, self).setAction(defSE.val.GET_ACTION_CODE)
        self.numPin = numPin
        return
    
    def pinSet(self, numPin, value):
        if value == 'H':
            super(Pin, self).setAction(defSE.val.ON_ACTION_CODE)
        elif value == 'L':
            super(Pin, self).setAction(defSE.val.OFF_ACTION_CODE)
        self.numPin = numPin
        return     
        
    def setup(self, paquet):
        if self.numPin in self.dicPins: 
            id = self.dicPins[self.numPin]
            port = id[0]
            bit = id[1]           
            paquet.addNum(port)
            paquet.addNum(bit)
        return
        