/**
 * Description: Funcions de control dels Leds
 *
 * author: David Otal Esclarin
 *
 * revision 1.0 date 09/03/2015
 */

#ifndef LEDLIBX_INC_LED_H_
#define LEDLIBX_INC_LED_H_

/* The bit of port 0 that the LPCXpresso LPC13xx LED is connected. */
#define mainLED_BIT 						( 22 )
/** Inicialitza els pins del led
 * @precondition 	cap
 * @param 			cap
 * @return 			void
 */
void led_init( void );
/** Encen un led
 * @precondition 	cap
 * @param 			cap
 * @return 			void
 */
void led_on( void );
/** Apaga un led
 * @precondition 	cap
 * @param 			cap
 * @return 			void
 */
void led_off( void );
/** Inverteix l'estat d'un led (encès/apagat)
 * @precondition 	cap
 * @param 			cap
 * @return 			void
 */
void led_toggle( void );



#endif /* LEDLIBX_INC_LED_H_ */
