'''
Created on 02/05/2015

@author: david
'''
from pyCSE import componentSE
from pyCSE import defSE


class Led(componentSE.ComponentSE):
    '''
    classdocs
    Control del component Led, per encendre i apagar.    
    '''
    ledState = "off"
    ledTime = 0
    
    def __init__(self):
        '''
        Constructor
        '''
        super(Led, self).setType(defSE.val.LED_CODE)
        super(Led, self).setAction(defSE.val.OFF_ACTION_CODE)        

    def on(self):
        self.ledState = "on"
        super(Led, self).setAction(defSE.val.ON_ACTION_CODE)
    
    def off(self):
        self.ledState = "off"
        super(Led, self).setAction(defSE.val.OFF_ACTION_CODE)

    def blink(self, newTime):
        self.ledState = "Blink"
        self.ledTime = newTime
        super(Led, self).setAction(defSE.val.BLINK_ACTION_CODE)
    
    def setup(self, paquet):
        if self.ledState == "Blink":
            paquet.addNum(self.ledTime)
        return
        
