'''
Created on 26/04/2015

@author: david

Clase de comunicacions mitjançat el port serie, amb la llibreria pySerial
'''
import serial
import struct
from pyCSE import defSE

class SerialCon(object):
    '''
    classdocs
    '''
    opened = 0
    cap = bytearray()
    def __init__(self):
        '''
        Constructor
        '''
        try:
            self.ser = serial.Serial('/dev/ttyUSB0', 9600, timeout=1)
            self.opened = 1;
        except(OSError):
            self.opened = 0
            print("Port Serie no disponible")

    def isOpen(self):
        return(self.opened)      
      
    def send(self, bytestream):
        if self.ser != 0:               
            long = len(bytestream)
            self.ser.write(bytestream)
            # print ('Long sended=' + str(long) )
            # s = struct.Struct( str(long) + 'B')
            # print ('Sended=' + str(s.unpack(bytestream) ) )
            
    
    def read(self):
        dades = bytes;
        if self.ser != 0:
            if self.ser.readable():                
                dades = self.ser.read(defSE.val.READ_SIZE)
                # print("API read=" + str(dades))                
            else:
                print('no disponible')        
        return dades;
            
        