'''
Created on 01/06/2015

@author: david

Clase de funcions i propietats de la UART  
'''
import pyCSE.componentSE
from pyCSE import defSE

class UART(pyCSE.componentSE.ComponentSE):
    
    '''
    classdocs
    '''
    myPort = 0
    mySpeed = 9600
    text = ''

    def __init__(self):
        '''
        Constructor
        '''
        super(UART, self).setType( defSE.val.UART_CODE)
        super(UART, self).setAction( defSE.val.GET_ACTION_CODE)

    def get(self, port, speed):
        super(UART, self).setAction(defSE.val.GET_ACTION_CODE)
        self.myPort = port
        self.mySpeed = speed
        self.text = ''        
    
    def send(self, port, speed, text):        
        super(UART, self).setAction(defSE.val.SET_ACTION_CODE )
        self.myPort = port
        self.mySpeed = speed
        self.text = text
        
    def setup(self, paquet): 
        paquet.addNum(self.myPort)
        paquet.addNum(self.mySpeed) 
        if self.text != '':
             paquet.addText(self.text)
                  